<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZExpansion: ExpansionMath Class Reference</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZExpansion<span id="projectnumber">&#160;1.7.12</span>
   </div>
   <div id="projectbrief">DayZExpansion Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('d3/d98/class_expansion_math.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="summary">
<a href="#pri-static-methods">Static Private Member Functions</a>  </div>
  <div class="headertitle"><div class="title">ExpansionMath Class Reference</div></div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pri-static-methods" name="pri-static-methods"></a>
Static Private Member Functions</h2></td></tr>
<tr class="memitem:adf82ec2acc0b91574840e1ba20b228d6"><td class="memItemLeft" align="right" valign="top">static float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#adf82ec2acc0b91574840e1ba20b228d6">LinearConversion</a> (float minFrom, float maxFrom, float value, float minTo=0, float maxTo=1, bool clamp=true)</td></tr>
<tr class="separator:adf82ec2acc0b91574840e1ba20b228d6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a507dd39bab045a3b8f34e45a0b9f9470"><td class="memItemLeft" align="right" valign="top">static float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#a507dd39bab045a3b8f34e45a0b9f9470">PowerConversion</a> (float minFrom, float maxFrom, float value, float minTo=0, float maxTo=1, float power=1.0)</td></tr>
<tr class="separator:a507dd39bab045a3b8f34e45a0b9f9470"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a46671c1c5b15a5748ea5446fd13a86cf"><td class="memItemLeft" align="right" valign="top">static float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#a46671c1c5b15a5748ea5446fd13a86cf">Clamp</a> (float value, float edge0=0, float edge1=1)</td></tr>
<tr class="separator:a46671c1c5b15a5748ea5446fd13a86cf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a43c2461c6b6defe2053a0c34b0afc68e"><td class="memItemLeft" align="right" valign="top">static float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#a43c2461c6b6defe2053a0c34b0afc68e">PascalTriangle</a> (int a, int b)</td></tr>
<tr class="separator:a43c2461c6b6defe2053a0c34b0afc68e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6040344ead1e539ad9a7d87452ae1521"><td class="memItemLeft" align="right" valign="top">static float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#a6040344ead1e539ad9a7d87452ae1521">SmoothStep</a> (float x, int N=1, float edge0=0, float edge1=1)</td></tr>
<tr class="separator:a6040344ead1e539ad9a7d87452ae1521"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7d1a5120786f88b26ffc279433fd6d0"><td class="memItemLeft" align="right" valign="top">static float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#af7d1a5120786f88b26ffc279433fd6d0">SCurve</a> (float x, float edge0=0, float edge1=1)</td></tr>
<tr class="memdesc:af7d1a5120786f88b26ffc279433fd6d0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Alternative to smoothstep.  <a href="../../d3/d98/class_expansion_math.html#af7d1a5120786f88b26ffc279433fd6d0">More...</a><br /></td></tr>
<tr class="separator:af7d1a5120786f88b26ffc279433fd6d0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9baeeb89726ccf435c169c649466b2d8"><td class="memItemLeft" align="right" valign="top">static vector&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#a9baeeb89726ccf435c169c649466b2d8">ExRotateAroundPoint</a> (vector point, vector pos, vector axis, float cosAngle, float sinAngle)</td></tr>
<tr class="separator:a9baeeb89726ccf435c169c649466b2d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab1945443c3ef04261d7f7c84ce7eff61"><td class="memItemLeft" align="right" valign="top">static vector&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#ab1945443c3ef04261d7f7c84ce7eff61">GetRandomPointAtDegrees</a> (vector center, float degrees, float minRadius, float maxRadius)</td></tr>
<tr class="memdesc:ab1945443c3ef04261d7f7c84ce7eff61"><td class="mdescLeft">&#160;</td><td class="mdescRight">Generate random point at angle in dregrees.  <a href="../../d3/d98/class_expansion_math.html#ab1945443c3ef04261d7f7c84ce7eff61">More...</a><br /></td></tr>
<tr class="separator:ab1945443c3ef04261d7f7c84ce7eff61"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a76acdd0931820e1359e51d0ea502d9a3"><td class="memItemLeft" align="right" valign="top">static vector&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#a76acdd0931820e1359e51d0ea502d9a3">GetRandomPointAtRadians</a> (vector center, float theta, float minRadius, float maxRadius)</td></tr>
<tr class="memdesc:a76acdd0931820e1359e51d0ea502d9a3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Generate random point at angle in radians.  <a href="../../d3/d98/class_expansion_math.html#a76acdd0931820e1359e51d0ea502d9a3">More...</a><br /></td></tr>
<tr class="separator:a76acdd0931820e1359e51d0ea502d9a3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0e283713bdffca3eb6a2f5f74e4ea81f"><td class="memItemLeft" align="right" valign="top">static vector&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#a0e283713bdffca3eb6a2f5f74e4ea81f">GetRandomPointInRing</a> (vector center, float minRadius, float maxRadius)</td></tr>
<tr class="memdesc:a0e283713bdffca3eb6a2f5f74e4ea81f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Generate random point within ring (uniformly)  <a href="../../d3/d98/class_expansion_math.html#a0e283713bdffca3eb6a2f5f74e4ea81f">More...</a><br /></td></tr>
<tr class="separator:a0e283713bdffca3eb6a2f5f74e4ea81f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a89e847a3c5391476b2fab0cd91dedd79"><td class="memItemLeft" align="right" valign="top">static vector&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#a89e847a3c5391476b2fab0cd91dedd79">GetRandomPointInCircle</a> (vector center, float radius)</td></tr>
<tr class="memdesc:a89e847a3c5391476b2fab0cd91dedd79"><td class="mdescLeft">&#160;</td><td class="mdescRight">Generate random point within circle (uniformly)  <a href="../../d3/d98/class_expansion_math.html#a89e847a3c5391476b2fab0cd91dedd79">More...</a><br /></td></tr>
<tr class="separator:a89e847a3c5391476b2fab0cd91dedd79"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aab3879bfbf90851cd8b08f1e5e0a212d"><td class="memItemLeft" align="right" valign="top">static float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#aab3879bfbf90851cd8b08f1e5e0a212d">RelAngle</a> (float angle)</td></tr>
<tr class="memdesc:aab3879bfbf90851cd8b08f1e5e0a212d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Converts angle in interval [0,360] to interval [-180,180].  <a href="../../d3/d98/class_expansion_math.html#aab3879bfbf90851cd8b08f1e5e0a212d">More...</a><br /></td></tr>
<tr class="separator:aab3879bfbf90851cd8b08f1e5e0a212d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2beed2cef1a07df5dac2d4db96efbc90"><td class="memItemLeft" align="right" valign="top">static float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#a2beed2cef1a07df5dac2d4db96efbc90">AbsAngle</a> (float angle)</td></tr>
<tr class="memdesc:a2beed2cef1a07df5dac2d4db96efbc90"><td class="mdescLeft">&#160;</td><td class="mdescRight">Converts angle in interval [-180,180] to interval [0,360].  <a href="../../d3/d98/class_expansion_math.html#a2beed2cef1a07df5dac2d4db96efbc90">More...</a><br /></td></tr>
<tr class="separator:a2beed2cef1a07df5dac2d4db96efbc90"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8e826f5def0384fd533036faf39148a0"><td class="memItemLeft" align="right" valign="top">static float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#a8e826f5def0384fd533036faf39148a0">AngleDiff2</a> (float a, float b)</td></tr>
<tr class="memdesc:a8e826f5def0384fd533036faf39148a0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns smallest possible angle difference.  <a href="../../d3/d98/class_expansion_math.html#a8e826f5def0384fd533036faf39148a0">More...</a><br /></td></tr>
<tr class="separator:a8e826f5def0384fd533036faf39148a0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a864531a95b257ed617c5391b441ee56b"><td class="memItemLeft" align="right" valign="top">static TFloatArray&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#a864531a95b257ed617c5391b441ee56b">MovingAvg</a> (TFloatArray values, int passes=1, TFloatArray weights=null, TIntArray protect=null)</td></tr>
<tr class="memdesc:a864531a95b257ed617c5391b441ee56b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Smooth values (moving average)  <a href="../../d3/d98/class_expansion_math.html#a864531a95b257ed617c5391b441ee56b">More...</a><br /></td></tr>
<tr class="separator:a864531a95b257ed617c5391b441ee56b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a337d6627212aa9e59cfdd28fe52c3d38"><td class="memItemLeft" align="right" valign="top">static private void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#a337d6627212aa9e59cfdd28fe52c3d38">_MovingAvg</a> (inout TFloatArray data, TFloatArray window, TIntArray protect)</td></tr>
<tr class="separator:a337d6627212aa9e59cfdd28fe52c3d38"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3b6964193e3a30480591237eb974c8f2"><td class="memItemLeft" align="right" valign="top">static TVectorArray&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#a3b6964193e3a30480591237eb974c8f2">PathInterpolated</a> (TVectorArray path, ECurveType curveType=ECurveType.CatmullRom, bool smooth=true)</td></tr>
<tr class="memdesc:a3b6964193e3a30480591237eb974c8f2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Interpolate path.  <a href="../../d3/d98/class_expansion_math.html#a3b6964193e3a30480591237eb974c8f2">More...</a><br /></td></tr>
<tr class="separator:a3b6964193e3a30480591237eb974c8f2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7b9934afa6666e1ca8bfda9ca34b5680"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#a7b9934afa6666e1ca8bfda9ca34b5680">Cmp</a> (int a, int b)</td></tr>
<tr class="memdesc:a7b9934afa6666e1ca8bfda9ca34b5680"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compares two numbers Returns 1 if a &gt; b, zero if a == b and -1 if a &lt; b This function can be used to work-around broken integer comparison involving negative numbers in EnForce <a href="https://feedback.bistudio.com/T167065">https://feedback.bistudio.com/T167065</a>.  <a href="../../d3/d98/class_expansion_math.html#a7b9934afa6666e1ca8bfda9ca34b5680">More...</a><br /></td></tr>
<tr class="separator:a7b9934afa6666e1ca8bfda9ca34b5680"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6a41e81c2ab0974ad267bb4c22ca6cad"><td class="memItemLeft" align="right" valign="top">static float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#a6a41e81c2ab0974ad267bb4c22ca6cad">RandomFloatInclusive</a> (float min, float max)</td></tr>
<tr class="memdesc:a6a41e81c2ab0974ad267bb4c22ca6cad"><td class="mdescLeft">&#160;</td><td class="mdescRight">Proper RandomFloatInclusive that does include endpoint, other than the one in EnMath.  <a href="../../d3/d98/class_expansion_math.html#a6a41e81c2ab0974ad267bb4c22ca6cad">More...</a><br /></td></tr>
<tr class="separator:a6a41e81c2ab0974ad267bb4c22ca6cad"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1976bbda83920514af13915242eb864f"><td class="memItemLeft" align="right" valign="top">static float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d98/class_expansion_math.html#a1976bbda83920514af13915242eb864f">Log2</a> (float x, float tolerance=1e-13)</td></tr>
<tr class="separator:a1976bbda83920514af13915242eb864f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p ><a class="el" href="../../d3/dd9/expansionmath_8c.html">ExpansionMath.c</a></p>
<p >DayZ Expansion Mod www.dayzexpansion.com © 2022 DayZ Expansion Mod Team</p>
<p >This work is licensed under the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License. To view a copy of this license, visit <a href="http://creativecommons.org/licenses/by-nc-nd/4.0/">http://creativecommons.org/licenses/by-nc-nd/4.0/</a>. </p>

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00014">14</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="a337d6627212aa9e59cfdd28fe52c3d38" name="a337d6627212aa9e59cfdd28fe52c3d38"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a337d6627212aa9e59cfdd28fe52c3d38">&#9670;&#160;</a></span>_MovingAvg()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static private void ExpansionMath::_MovingAvg </td>
          <td>(</td>
          <td class="paramtype">inout TFloatArray&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">TFloatArray&#160;</td>
          <td class="paramname"><em>window</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">TIntArray&#160;</td>
          <td class="paramname"><em>protect</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00194">194</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<a id="a2beed2cef1a07df5dac2d4db96efbc90" name="a2beed2cef1a07df5dac2d4db96efbc90"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2beed2cef1a07df5dac2d4db96efbc90">&#9670;&#160;</a></span>AbsAngle()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static float ExpansionMath::AbsAngle </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>angle</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Converts angle in interval [-180,180] to interval [0,360]. </p>

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00125">125</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<a id="a8e826f5def0384fd533036faf39148a0" name="a8e826f5def0384fd533036faf39148a0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8e826f5def0384fd533036faf39148a0">&#9670;&#160;</a></span>AngleDiff2()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static float ExpansionMath::AngleDiff2 </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>b</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns smallest possible angle difference. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">a</td><td><code>float</code> Angle in interval [0,360] </td></tr>
    <tr><td class="paramname">b</td><td><code>float</code> Target angle in interval [0,360] </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>float</code> - Angle difference in interval [-180,180] <div class="fragment"><div class="line">Print( <a class="code hl_class" href="../../d3/d98/class_expansion_math.html">ExpansionMath</a>.<a class="code hl_function" href="../../d3/d98/class_expansion_math.html#a8e826f5def0384fd533036faf39148a0">AngleDiff2</a>(270.0, 0.0) );</div>
<div class="line">Print( <a class="code hl_class" href="../../d3/d98/class_expansion_math.html">ExpansionMath</a>.<a class="code hl_function" href="../../d3/d98/class_expansion_math.html#a8e826f5def0384fd533036faf39148a0">AngleDiff2</a>(350.0, 1.0) );</div>
<div class="line">Print( <a class="code hl_class" href="../../d3/d98/class_expansion_math.html">ExpansionMath</a>.<a class="code hl_function" href="../../d3/d98/class_expansion_math.html#a8e826f5def0384fd533036faf39148a0">AngleDiff2</a>(60.0, 275.0) );</div>
<div class="line"> </div>
<div class="line">&gt;&gt; 90.0</div>
<div class="line">&gt;&gt; 11.0</div>
<div class="line">&gt;&gt; -145.0</div>
<div class="ttc" id="aclass_expansion_math_html"><div class="ttname"><a href="../../d3/d98/class_expansion_math.html">ExpansionMath</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d3/dd9/expansionmath_8c_source.html#l00014">expansionmath.c:15</a></div></div>
<div class="ttc" id="aclass_expansion_math_html_a8e826f5def0384fd533036faf39148a0"><div class="ttname"><a href="../../d3/d98/class_expansion_math.html#a8e826f5def0384fd533036faf39148a0">ExpansionMath::AngleDiff2</a></div><div class="ttdeci">static float AngleDiff2(float a, float b)</div><div class="ttdoc">Returns smallest possible angle difference.</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/dd9/expansionmath_8c_source.html#l00147">expansionmath.c:147</a></div></div>
</div><!-- fragment --> </dd></dl>

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00147">147</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<a id="a46671c1c5b15a5748ea5446fd13a86cf" name="a46671c1c5b15a5748ea5446fd13a86cf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a46671c1c5b15a5748ea5446fd13a86cf">&#9670;&#160;</a></span>Clamp()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static float ExpansionMath::Clamp </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>edge0</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>edge1</em> = <code>1</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00032">32</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<a id="a7b9934afa6666e1ca8bfda9ca34b5680" name="a7b9934afa6666e1ca8bfda9ca34b5680"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7b9934afa6666e1ca8bfda9ca34b5680">&#9670;&#160;</a></span>Cmp()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int ExpansionMath::Cmp </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>b</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Compares two numbers Returns 1 if a &gt; b, zero if a == b and -1 if a &lt; b This function can be used to work-around broken integer comparison involving negative numbers in EnForce <a href="https://feedback.bistudio.com/T167065">https://feedback.bistudio.com/T167065</a>. </p>

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00401">401</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<a id="a9baeeb89726ccf435c169c649466b2d8" name="a9baeeb89726ccf435c169c649466b2d8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9baeeb89726ccf435c169c649466b2d8">&#9670;&#160;</a></span>ExRotateAroundPoint()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static vector ExpansionMath::ExRotateAroundPoint </td>
          <td>(</td>
          <td class="paramtype">vector&#160;</td>
          <td class="paramname"><em>point</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">vector&#160;</td>
          <td class="paramname"><em>pos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">vector&#160;</td>
          <td class="paramname"><em>axis</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>cosAngle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>sinAngle</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00076">76</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<a id="ab1945443c3ef04261d7f7c84ce7eff61" name="ab1945443c3ef04261d7f7c84ce7eff61"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab1945443c3ef04261d7f7c84ce7eff61">&#9670;&#160;</a></span>GetRandomPointAtDegrees()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static vector ExpansionMath::GetRandomPointAtDegrees </td>
          <td>(</td>
          <td class="paramtype">vector&#160;</td>
          <td class="paramname"><em>center</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>degrees</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>minRadius</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>maxRadius</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Generate random point at angle in dregrees. </p>

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00082">82</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<a id="a76acdd0931820e1359e51d0ea502d9a3" name="a76acdd0931820e1359e51d0ea502d9a3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a76acdd0931820e1359e51d0ea502d9a3">&#9670;&#160;</a></span>GetRandomPointAtRadians()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static vector ExpansionMath::GetRandomPointAtRadians </td>
          <td>(</td>
          <td class="paramtype">vector&#160;</td>
          <td class="paramname"><em>center</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>theta</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>minRadius</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>maxRadius</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Generate random point at angle in radians. </p>

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00090">90</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<a id="a89e847a3c5391476b2fab0cd91dedd79" name="a89e847a3c5391476b2fab0cd91dedd79"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a89e847a3c5391476b2fab0cd91dedd79">&#9670;&#160;</a></span>GetRandomPointInCircle()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static vector ExpansionMath::GetRandomPointInCircle </td>
          <td>(</td>
          <td class="paramtype">vector&#160;</td>
          <td class="paramname"><em>center</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>radius</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Generate random point within circle (uniformly) </p>

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00108">108</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<a id="a0e283713bdffca3eb6a2f5f74e4ea81f" name="a0e283713bdffca3eb6a2f5f74e4ea81f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0e283713bdffca3eb6a2f5f74e4ea81f">&#9670;&#160;</a></span>GetRandomPointInRing()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static vector ExpansionMath::GetRandomPointInRing </td>
          <td>(</td>
          <td class="paramtype">vector&#160;</td>
          <td class="paramname"><em>center</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>minRadius</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>maxRadius</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Generate random point within ring (uniformly) </p>

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00100">100</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<a id="adf82ec2acc0b91574840e1ba20b228d6" name="adf82ec2acc0b91574840e1ba20b228d6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adf82ec2acc0b91574840e1ba20b228d6">&#9670;&#160;</a></span>LinearConversion()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static float ExpansionMath::LinearConversion </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>minFrom</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>maxFrom</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>minTo</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>maxTo</em> = <code>1</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>clamp</em> = <code>true</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00016">16</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<a id="a1976bbda83920514af13915242eb864f" name="a1976bbda83920514af13915242eb864f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1976bbda83920514af13915242eb864f">&#9670;&#160;</a></span>Log2()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static float ExpansionMath::Log2 </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>tolerance</em> = <code>1e-13</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p >Proper Log2. Vanilla Math.Log2 signature gives the impression it works with floats. It doesn't, it's a purely integer implementation. Adapted from <a href="https://stackoverflow.com/a/3719696">https://stackoverflow.com/a/3719696</a> </p><dl class="section note"><dt>Note</dt><dd>tolerance sets the accuracy of the result and should not be lower than 1e-15 (no accuracy improvement past that point) </dd></dl>
<p >We need to return something, unfortunately EnForce doesn't have a NaN value</p>
<p >Shortcut for x == 1.0</p>
<p >Shortcut for x == 0.5</p>
<p >Integer part</p>
<p >Fractional part</p>

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00428">428</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<a id="a864531a95b257ed617c5391b441ee56b" name="a864531a95b257ed617c5391b441ee56b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a864531a95b257ed617c5391b441ee56b">&#9670;&#160;</a></span>MovingAvg()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static TFloatArray ExpansionMath::MovingAvg </td>
          <td>(</td>
          <td class="paramtype">TFloatArray&#160;</td>
          <td class="paramname"><em>values</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>passes</em> = <code>1</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">TFloatArray&#160;</td>
          <td class="paramname"><em>weights</em> = <code>null</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">TIntArray&#160;</td>
          <td class="paramname"><em>protect</em> = <code>null</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Smooth values (moving average) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">passses</td><td>Number of passes </td></tr>
    <tr><td class="paramname">weights</td><td>Float array containing weighting factors. Its length determines the size of the window to use. Defaults to {1.0, 1.0, 1.0} </td></tr>
    <tr><td class="paramname">protect</td><td>Int array containing indexes of values to protect </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00166">166</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<a id="a43c2461c6b6defe2053a0c34b0afc68e" name="a43c2461c6b6defe2053a0c34b0afc68e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a43c2461c6b6defe2053a0c34b0afc68e">&#9670;&#160;</a></span>PascalTriangle()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static float ExpansionMath::PascalTriangle </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>b</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p >Returns binomial coefficient without explicit use of factorials, which can't be used with negative integers </p>

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00041">41</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<a id="a3b6964193e3a30480591237eb974c8f2" name="a3b6964193e3a30480591237eb974c8f2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3b6964193e3a30480591237eb974c8f2">&#9670;&#160;</a></span>PathInterpolated()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static TVectorArray ExpansionMath::PathInterpolated </td>
          <td>(</td>
          <td class="paramtype">TVectorArray&#160;</td>
          <td class="paramname"><em>path</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ECurveType&#160;</td>
          <td class="paramname"><em>curveType</em> = <code>ECurveType.CatmullRom</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>smooth</em> = <code>true</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Interpolate path. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">path</td><td>Array of vectors </td></tr>
    <tr><td class="paramname">curveType</td><td>The type of curve that should be used for interpolation </td></tr>
    <tr><td class="paramname">smooth</td><td>If path should be smoothed after applying curve interpolation (may help against overly sharp changes in angle) </td></tr>
  </table>
  </dd>
</dl>
<p >1st pass - insert linearly interpolated points roughly every 100 m where needed to make path more evenly spaced (helps against overly sharp turns in curve interpolation)</p>
<p >Curve interpolation</p>
<p >Smoothing pass - moving avg</p>
<p >Final pass - set Y to surface</p>

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00240">240</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<a id="a507dd39bab045a3b8f34e45a0b9f9470" name="a507dd39bab045a3b8f34e45a0b9f9470"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a507dd39bab045a3b8f34e45a0b9f9470">&#9670;&#160;</a></span>PowerConversion()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static float ExpansionMath::PowerConversion </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>minFrom</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>maxFrom</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>minTo</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>maxTo</em> = <code>1</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>power</em> = <code>1.0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p >value must be equal to or between 0 and 1</p>

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00026">26</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<a id="a6a41e81c2ab0974ad267bb4c22ca6cad" name="a6a41e81c2ab0974ad267bb4c22ca6cad"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6a41e81c2ab0974ad267bb4c22ca6cad">&#9670;&#160;</a></span>RandomFloatInclusive()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static float ExpansionMath::RandomFloatInclusive </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>min</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>max</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Proper RandomFloatInclusive that does include endpoint, other than the one in EnMath. </p>

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00415">415</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<a id="aab3879bfbf90851cd8b08f1e5e0a212d" name="aab3879bfbf90851cd8b08f1e5e0a212d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aab3879bfbf90851cd8b08f1e5e0a212d">&#9670;&#160;</a></span>RelAngle()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static float ExpansionMath::RelAngle </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>angle</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Converts angle in interval [0,360] to interval [-180,180]. </p>

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00117">117</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<a id="af7d1a5120786f88b26ffc279433fd6d0" name="af7d1a5120786f88b26ffc279433fd6d0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af7d1a5120786f88b26ffc279433fd6d0">&#9670;&#160;</a></span>SCurve()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static float ExpansionMath::SCurve </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>edge0</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>edge1</em> = <code>1</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Alternative to smoothstep. </p>
<p >x must be equal to or between 0 and 1</p>

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00065">65</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<a id="a6040344ead1e539ad9a7d87452ae1521" name="a6040344ead1e539ad9a7d87452ae1521"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6040344ead1e539ad9a7d87452ae1521">&#9670;&#160;</a></span>SmoothStep()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static float ExpansionMath::SmoothStep </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>N</em> = <code>1</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>edge0</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>edge1</em> = <code>1</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p >Generalized smoothstep <a href="https://en.wikipedia.org/wiki/Smoothstep#Generalization_to_higher-order_equations">https://en.wikipedia.org/wiki/Smoothstep#Generalization_to_higher-order_equations</a> This function is well-behaved up to including N=5. Beyond that, errors accumulate, until the function eventually breaks. </p>
<p >x must be equal to or between 0 and 1</p>

<p class="definition">Definition at line <a class="el" href="../../d3/dd9/expansionmath_8c_source.html#l00053">53</a> of file <a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>DayzExpansion/Core/Scripts/3_game/dayzexpansion_core/<a class="el" href="../../d3/dd9/expansionmath_8c_source.html">expansionmath.c</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../d3/d98/class_expansion_math.html">ExpansionMath</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
